void __fastcall TDesignForm::VportMouseDown(TObject*,
  TMouseButton Button, TShiftState Shift, int X, int Y)
{
  ActiveControl = D3dView;
  FButton = Button; //   ViewSelect()

  //   :
  lastX = X; lastY = Y;
  ILastSelBuilder  = ISelBuilder;
  ILastSelFace     = ISelFace;
  LastSelVertex    = SelVertex;
  //  :
  ViewSelect(X, Y);
  //    :
  if (ISelBuilder)  FindSelected(this);
  UpdateTools(this); //    
  //      .
}//---------------------------------------------------------
void __fastcall TDesignForm::ViewSelect(int X, int Y) {
  RELEASE(ISelFace);
  RELEASE(ISelBuilder);
  RELEASE(ISelFrame);
  SelVertex = 0;

  LPDIRECT3DRMVISUAL      Ivisual;
  LPDIRECT3DRMFRAMEARRAY  IFrames;
  LPDIRECT3DRMPICKEDARRAY IPicks;
  D3DRMPICKDESC PickDesc;

  Vport->IRMVport->Pick(X, Y, &IPicks);
  if (!IPicks->GetSize()) {
     RELEASE(IPicks);
     return;
  }
  //   :
  IPicks->GetPick(0, &Ivisual, &IFrames, &PickDesc);
  RELEASE(IPicks); //     , 
  //    -   .
  IFrames->GetElement(IFrames->GetSize()-1, &ISelFrame);
  RELEASE(IFrames);

  if (IsBuilder(Ivisual)) { //   
     ISelBuilder = LPDIRECT3DRMMESHBUILDER(Ivisual);
     if (ISelBuilder == ILastSelBuilder) {
        //        ,
        //    :
        LPDIRECT3DRMFACEARRAY IFaces = NULL;
        ISelBuilder->GetFaces(&IFaces);
        if (FButton == mbLeft) //  :
          IFaces->GetElement(PickDesc.ulFaceIdx, &ISelFace);
        else
        if (FButton == mbRight) //  :
          ISelFace = GetFaceAt(Vport->IRMVport, ISelFrame,
                                              IFaces, X, Y);
        RELEASE(IFaces);
        //       ,
        //     :
        if (ISelFace == ILastSelFace) SelectVertex(X, Y);
     }
  }
  RELEASE(Ivisual);
}//---------------------------------------------------------
void __fastcall TDesignForm::SelectVertex(int X, int Y) {
  if (!ISelFace || !ISelBuilder)  return;

  DWORD vcount;
  D3DVECTOR *vlist;
  //     :
  ISelFace->GetVertices(&vcount, NULL, NULL);
  //   :
  vlist  = new D3DVECTOR[vcount];
  //      :
  ISelFace->GetVertices(&vcount, vlist, NULL);
  int x, y;
  D3DVECTOR vpos;
  //    :
  D3dView->SetCSFrame(ISelFrame);
  for (DWORD i = 0; i < vcount; i++) {
     //    :
     Vport->Vec2xy(&vlist[i], x, y);
     //       5 :
     if ((x<X+5)&&(x>X-5)&&(y<Y+5)&&(y>Y-5)) {
        vpos = vlist[i]; //   
        break; //  !
     }
  }
  delete[] vlist;
  //        
  //  (  ):
  DWORD ncount , flsize;
  //     :
  ISelBuilder->GetVertices(&vcount, NULL,
                           &ncount, NULL,
                           &flsize, NULL);
  //   :
  vlist = new D3DVECTOR[vcount];
  //      :
  ISelBuilder->GetVertices(&vcount, vlist,
                           &ncount, NULL,
                           &flsize, NULL);
  for (DWORD i = 0; i < vcount; i++) {
     //      
     if (memcmp(&vpos, &vlist[i], sizeof vpos) == 0) {
       SelVertex = i; // SelVertex   
       //       
       break; // !
     }
  }
  delete [] vlist;
}//---------------------------------------------------------
void __fastcall TDesignForm::FindSelected(TObject*) {
  if (!ISelBuilder) return;
  TTreeNode* Node = Tree->Items->GetFirstNode();
  while (Node) {
     if (Node->Data == ISelBuilder) break;
     Node = Node->GetNext();
  }
  if (Node) {
     Node->MakeVisible();
     Tree->Selected = Node;
  }
}//---------------------------------------------------------
